package ru.ulstu.fc.rule.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import ru.ulstu.fc.rule.model.VariableForm;
import ru.ulstu.fc.rule.service.VariableService;

@Controller
@RequestMapping("var")
public class VariableController {
    private final VariableService variableService;

    public VariableController(VariableService variableService) {
        this.variableService = variableService;
    }

    @GetMapping("/edit/{projectId}/{varId}")
    public String edit(@PathVariable(value = "projectId") Integer projectId,
            @PathVariable(value = "varId") Integer id, Model model) {
        model.addAttribute("projectId", projectId);
        model.addAttribute("var",
                new VariableForm(id, (id != null && id != 0)
                        ? variableService.getById(id).getProject().getId()
                        : projectId));

        return "var/edit";
    }

    @PostMapping(value = "save", params = "save")
    public String save(VariableForm variableForm, Model model) {
        model.addAttribute("rule", variableService.save(variableForm));
        return "redirect:/project/edit/" + variableForm.getProjectId();
    }

    @PostMapping(value = "save", params = "delete")
    public String delete(VariableForm variableForm) {
        if (variableForm != null && variableForm.getId() != null) {
            variableService.delete(variableForm);
        }
        return "redirect:/project/edit/" + variableForm.getProjectId();
    }
}
